% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EagerFuture-class.R
\name{EagerFuture-class}
\alias{EagerFuture}
\alias{EagerFuture-class}
\title{An eager future is a future whose value will be resolved immediately}
\usage{
EagerFuture(expr = NULL, envir = parent.frame(), substitute = FALSE,
  local = TRUE, gc = FALSE, ...)
}
\arguments{
\item{expr}{An R \link[base]{expression}.}

\item{envir}{The \link{environment} in which the evaluation
is done (or inherits from if \code{local} is TRUE).}

\item{substitute}{If TRUE, argument \code{expr} is
\code{\link[base]{substitute}()}:ed, otherwise not.}

\item{local}{If TRUE, the expression is evaluated such that
all assignments are done to local temporary environment, otherwise
the assignments are done in the calling environment.}

\item{gc}{If TRUE, the garbage collector run after the future is resolved.}

\item{\dots}{Additional named elements of the future.}
}
\value{
An object of class \code{EagerFuture}.
}
\description{
An eager future is a future whose value will be resolved immediately
}
\seealso{
To evaluate an expression using "eager future", see function
\code{\link{eager}()}.
}
\keyword{internal}

